Rem GPU bezier/arc/ellipse tester written in 'FreeBasic'
REM Setup by Brian Guralnick
REM 
REM Get the freeBasic compiler at 
REM 
REM 


Declare Sub draw_pixel(xp as integer, yp as integer, colr as Ubyte, colg as Ubyte, colb as Ubyte)  : REM Draws 1 dot with paleted Color
Declare Sub drawLine(x1 as integer, y1 as integer, x2 as integer, y2 As Integer, cr As Ubyte, cg As Ubyte, cb As Ubyte)

Declare Sub draw_ellipse(ByVal xc As integer, ByVal yc As Integer, ByVal a As integer, ByVal b As Integer)


dim Shared as integer mx,mxl,my,myl,mb,mbl,mw,mwl,sx,sy,dx,dy,dz
dim Shared as integer destmem, srcmem, max_x,max_y, src_width, dest_width
dim shared as Ubyte   show_pset
dim shared as string ink

ScreenRes 720,560,16,0,0 : REM open a window a little larger than 640x480


REM *************************************************************
REM **** Loop drawing the ellipse using the mouse choordinates **
REM **** Use the ESC key to quit **
REM *************************************************************

ink=""
while ink<>chr(27)

getmouse mx,my,mw,mb
mx=mx-8
my=my-8

               if mx<>mxl or my<>myl or mb<>mbl then
               
               line (0,0)-(719,559),rgb( 0,0,0 ),BF : rem rem cls fast

               sx = 320
               sy = 240
               dx = abs(320-mx)
               dy = abs(240-my)

               REM These coordinates define points P0,P1,P2 for a Bzier curve top left side
               drawLine (sx,sy,mx,my,128,96,64) 
               drawLine (sx,sy,320,my,128,96,64) 
               drawLine (sx,sy,mx,240,128,96,64) 
               rem Drawline as a line 
               draw_ellipse (sx,sy,dx,dy) 
               rem Drawline as an arc
 


               mxl=mx:myl=my:mbl=mb:mw=mwl : rem store old mouse state


               color rgb(255,255,255),rgb(0,0,0)
               locate 62,1
               ? " coord 1ab  (";sx;",";sy;")-(";dx;",";dy;")        "
               ? " width      (";dz;")        ";
                
               end if

sleep 1: rem wait for a keypress before quitting
ink=inkey
wend
end



REM *************************************************************
REM **** Draw LINE-ARC with the palette color ************
REM *************************************************************


Sub draw_ellipse (ByVal xc As integer, ByVal yc As Integer, ByVal a As integer, ByVal b As Integer)

	Dim As Integer x, y, sigma, xd
	Dim As Integer a2 = a*a, b2 = b*b, fa2 = 4*a2, fb2 = 4*b2
        Dim As Integer cr,cg,cb


cr=255:cg=0:cb=0

	x=0
	y=b
	sigma = 2*b2+a2*(1-2*b)
   While (b2*x <= a2*y)
      draw_pixel(xc+x, yc+y, cr, cg, cb) : Rem   I. Quadrant
      draw_pixel(xc-x, yc+y, cr, cg, cb) : Rem   II. Quadrant
      draw_pixel(xc+x, yc-y, cr, cg, cb) : Rem   III. Quadrant
      draw_pixel(xc-x, yc-y, cr, cg, cb) : Rem   IV. Quadrant
     
		
		If (sigma>= 0) Then
			sigma += fa2*(1-y)
			y=y-1
		EndIf
		sigma = sigma + b2*(4*x+6)
		x=x+1
   Wend




cr=0:cg=255:cb=0
   
   x=a
   y=0
   sigma = 2*a2+b2*(1-2*a)
   While (a2*y <= b2*x)
      draw_pixel(xc+x, yc+y, cr, cg, cb) : Rem   I. Quadrant
      draw_pixel(xc-x, yc+y, cr, cg, cb) : Rem   II. Quadrant
      draw_pixel(xc+x, yc-y, cr, cg, cb) : Rem   III. Quadrant
      draw_pixel(xc-x, yc-y, cr, cg, cb) : Rem   IV. Quadrant
		
		
		If (sigma>= 0) Then
			sigma += fb2*(1-x)
			x=x-1
		EndIf
		sigma = sigma + a2*(4*y+6)
		y=y+1
   Wend
  


	
End Sub

REM *************************************************************
REM **** Draw Line Using Bresenham's algorithm ************
REM *************************************************************

Sub drawLine (ByVal x0 as Integer, byval y0 as Integer, byval x1 as Integer, byval y1 as Integer, byval cr As UByte, byval cg As UByte, byval cb As UByte) 
    Dim As integer  dx,dy,x,y,sx,sy,errd,magic
    Dim As boolean is_done


    Rem bounding box's width and height
    Rem set the loop's sign
    dx = x1 - x0
    dy = y1 - y0
    
    if (dx < 0) Then
        dx = -dx
        sx = -1
    Else
        sx = 1
    End If
    
    if (dy > 0) Then
        dy = -dy
        sy = 1
    Else
        sy = -1
    End If

    magic = 0
    errd  = dx + dy
    x     = x0
    y     = y0
    is_done = FALSE
    
   While (is_done = False)

      draw_pixel (x,y,cr,cg,cb)

      Rem Reached the End
      If (x = x1 And y = y1) Then
      	is_done = TRUE
      Else
      	is_done = FALSE
      End If

      Rem Loop carried
      magic = errd shl 1
      if (magic > dy) Then
         errd += dy
         x    += sx
      End If
        
      if (magic < dx) Then
         errd += dx
         y    += sy
      End If
   Wend

End Sub



REM *************************************************************
REM **** Draw a dot with the palette color ************
REM *************************************************************

Sub draw_pixel(xp as integer, yp as integer, colr as Ubyte, colg as Ubyte, colb as Ubyte)
	PSet ( xp,yp ),rgb( colr,colg,colb )
end sub
